"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_jss_1 = require("react-jss");
var recharts_1 = require("recharts");
var useStyles = react_jss_1.createUseStyles({
    outerContainer: {
        height: "100%",
        width: "100%",
        backgroundColor: "var(--theia-button-background)",
        color: "var(--theia-button-foreground)",
        "&:hover": {
            backgroundColor: "var(--theia-button-hoverBackground)",
        },
        borderRadius: "6px",
        marginTop: 36,
    },
    subTitle: {
        color: "var(--theia-descriptionForeground)",
        fontSize: 18,
        margin: "8px 0 24px 0",
    },
    label: {
        margin: 0,
        fontWeight: 600,
        color: "var(--theia-descriptionForeground)",
        fontSize: 24,
    },
    headerContainer: {
        padding: 24,
    },
});
var ChartContainer = function (props) {
    var children = props.children, title = props.title, description = props.description, _a = props.height, height = _a === void 0 ? 500 : _a;
    var classes = useStyles();
    return (React.createElement("div", { className: classes.outerContainer },
        React.createElement("div", { className: classes.headerContainer },
            React.createElement("p", { className: classes.label }, title),
            React.createElement("p", { className: classes.subTitle }, description)),
        React.createElement(recharts_1.ResponsiveContainer, { height: height, width: "100%" }, children)));
};
exports.default = ChartContainer;
//# sourceMappingURL=ChartContainer.js.map