"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var recharts_1 = require("recharts");
var MetricWidgetContext_1 = require("../MetricWidgetContext");
var react_1 = require("@theia/core/shared/react");
var ChartContainer_1 = require("../ChartContainer");
var PieChartWidget = function (props) {
    var widget = props.widget;
    var title = widget.title, description = widget.description, _a = widget.height, height = _a === void 0 ? 500 : _a, config = widget.config, response_format = widget.response_format, metric_url = widget.metric_url, _b = widget.fill_color, fill_color = _b === void 0 ? "blue" : _b;
    var _c = MetricWidgetContext_1.useMetricWidgetContext(), getValueByKey = _c.getValueByKey, globalResponse = _c.globalResponse, responseDict = _c.responseDict, globalResponseFormat = _c.globalResponseFormat;
    var _d = __read(react_1.useState([]), 2), parsedData = _d[0], setParsedData = _d[1];
    react_1.useEffect(function () {
        parseData();
    }, [
        JSON.stringify(globalResponse),
        JSON.stringify(responseDict),
        globalResponseFormat,
    ]);
    var parseData = function () {
        var parsedDataArr = [];
        config === null || config === void 0 ? void 0 : config.forEach(function (item) {
            parsedDataArr.push({
                name: item.label,
                value: getValueByKey({
                    key: item.key,
                    responseFormat: response_format,
                    metricUrl: metric_url,
                }),
            });
        });
        setParsedData(parsedDataArr);
    };
    return (React.createElement(ChartContainer_1.default, { height: height + 96, title: title, description: description },
        React.createElement(recharts_1.PieChart, { height: height + 96 },
            React.createElement(recharts_1.Pie, { data: parsedData, dataKey: "value", nameKey: "name", label: true, labelLine: true, isAnimationActive: false, fill: "var(--theia-charts-" + fill_color + ")" }),
            React.createElement(recharts_1.Tooltip, null))));
};
exports.default = PieChartWidget;
//# sourceMappingURL=PieChartWidget.js.map