import { EMetricWidgetType, EResponseFormat } from "../constants";

export interface IMetricWidgetContext {
  globalResponse: any;
  globalResponseFormat?: EResponseFormat;
  responseDict: IResponseDict;
  fetchMetricUrl: (
    url?: string,
    responseFormat?: EResponseFormat,
    isGlobal?: boolean
  ) => void;
  getValueByKey: (options: IGetValueOptions) => any;
}
export interface IMetricWidgetProvider {
  children: React.ReactNode;
  metricUrl: string;
  responseFormat: EResponseFormat;
}

export interface IResponseDict {
  [url: string]: IResponse;
}

export interface IResponse {
  data: any;
}

export interface IGetValueOptions {
  key: string;
  keySeparator?: string;
  metricUrl?: string;
  responseFormat?: EResponseFormat;
}

export interface IBarChartKeyConfig {
  key: string;
  label: string;
}

export interface IBarChartConfig {
  key: string;
  label?: string;
}

export interface IPieChartConfig {
  key: string;
  label?: string;
}

export interface IChartConfig extends IPieChartConfig, IBarChartConfig {}

export interface IMetricWidget {
  title: string;
  value_key: string;
  key_separator?: string;
  widgets?: IMetricWidget[];
  type: EMetricWidgetType;
  description_key?: string;
  unit?: string;
  description?: string;
  metric_url?: string;
  response_format?: EResponseFormat;
  x_axis_label?: string;
  y_axis_label?: string;
  config?: IChartConfig[];
  fallback_value?: string;
  height?: number;
  fill_color?: "blue" | "purple" | "red" | "yellow" | "orange" | "green";
}
